#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <mpi.h>

#define EXACT_PI 3.1415926533589793238462643

double mat1(double x, double y);

main(argc, argv)
int argc;
char *argv[];
{

int n = 10;
int i,j, t, size, my_grid_rank;
MPI_Comm comm2d;
int dims[2], wrap_around[2], reorder = 1, coords[2];
double mat2[4];
double x, y, h, beginx, beginy, endx, endy, pisquared;

MPI_Init(&argc, &argv);
MPI_Comm_rank(MPI_COMM_WORLD, &my_grid_rank);
MPI_Comm_size(MPI_COMM_WORLD, &size);

t = sqrt(size);

dims[0] = dims[1] = t;

wrap_around[0] = wrap_around[1] = 1; 

MPI_Cart_create(MPI_COMM_WORLD, 2, dims, wrap_around, reorder, &comm2d);
/* MPI_Comm_rank(comm2d, &my_grid_rank); */
MPI_Cart_coords(comm2d, my_grid_rank, 2, coords);

h = 1/(double)n;

beginx = (double)coords[0]/(double)t;
beginy = (double)coords[1]/(double)t;
endx = (double)coords[0]/(double)t + 0.5; 
endy = (double)coords[1]/(double)t + 0.5; 

for (x=beginx; x<endx; x+=h)

{ for (y=beginy; y<endy; y+=h)

{ pisquared += (h*h) * (mat1(x,y) + mat1(x,y+h) + mat1(x+h,y) + mat1(x+h,y+h))/4;

}

}

pisquared = 16 * pisquared;

MPI_Gather(&pisquared, 1, MPI_DOUBLE, &mat2, 1, MPI_DOUBLE, 0, comm2d);

if(my_grid_rank == 0)

{ pisquared = 0.0; 

for(i = 0; i < size; i++)

pisquared += mat2[i];

#if 0
printf("The value of pi squared is: %f\n", fabs(3.14 * EXACT_PI));
#endif

printf("The value of pi squared is: %.16f\n",pisquared );
}

MPI_Finalize();

}

double mat1(double x, double y)

{ return (double)1/((1.0 +x*x) *(1.0 + y*y));
}
